#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_game_battle_field.h"
std::auto_ptr<M_game_battle_field> M_game_battle_field::msSingleton(nullptr);

int M_game_battle_field::GetCount()
{
	return (int)mMapData.size();
}

const M_game_battle_fieldData* M_game_battle_field::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int64_t, M_game_battle_fieldData>& M_game_battle_field::GetMapData()
{
	return mMapData;
}

void M_game_battle_field::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_game_battle_field.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_game_battle_fieldData data;
		data.mscene_type = element->IntAttribute("scene_type");
		data.mweight = element->IntAttribute("weight");
		data.mmax_num = element->IntAttribute("max_num");
		{
			const char* kill_count = element->Attribute("kill_count");
			std::vector<std::string> veckill_count;
			boost::split(veckill_count, kill_count, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veckill_count.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veckill_count[i].c_str(), &temp))
				{
					data.mkill_count.push_back(temp);
				}
			}
		}
		data.maward_drop_prob = element->FloatAttribute("award_drop_prob");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_game_battle_field Loaded. Load Data:%u", mMapData.size());
}

void M_game_battle_field::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_game_battle_field");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_game_battle_field");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_game_battle_fieldData data;
		LuaCfgHelper::readInt(L, "scene_type", data.mscene_type);
		LuaCfgHelper::readInt(L, "weight", data.mweight);
		LuaCfgHelper::readInt(L, "max_num", data.mmax_num);
		LuaCfgHelper::readVectorInt(L, "kill_count", data.mkill_count);
		LuaCfgHelper::readFloat(L, "award_drop_prob", data.maward_drop_prob);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_game_battle_field Loaded. Load Data:%u", mMapData.size());
}

void M_game_battle_field::Reload()
{
	mMapData.clear();
	Load();
}

M_game_battle_field* M_game_battle_field::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_game_battle_field());
	}
	return msSingleton.get();
}

void M_game_battle_field::Release()
{
	msSingleton.reset(nullptr);
}
